///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// EX-bot サンプルプログラム　2017/10/4　SooZoo-ROBOTECHNO
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//【免責事項】
//  本プログラムはサンプルプログラムであるため、SooZoo-ROBOTECHNO（以降、SZRと表記）は、
//  本プログラムに関して一切の動作保証をするものではありません。
//  また、本プログラムに不備があっても、SZRはその修正および、その他いかなる保守作業をする義務を負いません。
//  SZRは、本プログラムで発生した結果、および生成物について保証するものではありません。
//  また、本プログラムの使用により生じた損害ならびに、第三者に直接または間接的に生じた損害について、
//  SZRは法律上の根拠を問わずいかなる責任も負わないものとし、お客様はいかなる請求もしないものとします。
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <Servo.h>


#define IR_PIN      2       // 赤外線受信モジュール接続ピン番号
#define DATA_POINT  3       // 受信したデータから読取る内容のデータ位置(リモコンの押すボタンによって変わるデータの位置を記載する)
//3バイト目
#define ADVANCE     0x46      //前進
#define RECESSINON  0x15      //後退
#define TURN_R      0x43      //右回転
#define TURN_L      0x44      //左回転
#define OK_BUTTON   0x40
#define BUTTON_1    0x16
#define BUTTON_2    0x19
#define BUTTON_3    0x0D
#define BUTTON_4    0x0C
#define BUTTON_5    0x18
#define BUTTON_6    0x5E
#define BUTTON_7    0x08
#define BUTTON_8    0x1C
#define BUTTON_9    0x5A
#define BUTTON_KOME   0x42
#define BUTTON_0      0x52
#define BUTTON_SHARP  0x4A
#define ONCYCLE   100    //モータ用PWM　ON時間
#define OFFCYCLE  20     //モータ用PWM　ODFF時間


int key = -1;
int oldkey = -1;
int ans ;
//ADKeyboard Module
int adc_key_val[5] = {20, 50, 100, 200, 600};
int adc_key_in;
int NUM_KEYS = 5;
int mode = 0;                         //アナログコントローラの赤ボタン（右、左）を押すとモードが切り替わる
int motorPwmOnCounter = 0;            //モーター用PWM　ONカウンタ
int motorPwmOffCounter = 0;          //モーター用PWM　OFFカウンタ

Servo servo_1;  // create servo object to control a servo
Servo servo_2;  // create servo object to control a servo
Servo servo_3;  // create servo object to control a servo
Servo servo_4;  // create servo object to control a servo

// twelve servo objects can be created on most boards
int pos = 0;    // variable to store the servo position


// 初期化処理
void setup()
{
  // put your setup code here, to run once:
  //MotorDriverTA7291P
  pinMode(8, OUTPUT);    //Motor1 IN1
  pinMode(9, OUTPUT);    //Motor1 IN1
  pinMode(10, OUTPUT);   //Motor1 IN1
  pinMode(11, OUTPUT);   //Motor1 IN1
  //pinMode(IR_PIN, INPUT) ; // 赤外線受信モジュールに接続ピンをデジタル入力に設定

  servo_1.attach(0);  // attaches the servo on pin 9 to the servo object
  servo_2.attach(1);  // attaches the servo on pin 9 to the servo object
  servo_3.attach(2);  // attaches the servo on pin 9 to the servo object
  servo_4.attach(3);  // attaches the servo on pin 9 to the servo object

  //Serial.begin(9600) ; // パソコン(ArduinoIDE)とシリアル通信の準備を行う
  //Serial.println("start");
  //  digitalWrite(13, HIGH);
  //  delay(500);
}
// メインの処理
void loop()
{

  //指令データ受け取り元を赤外線からアナログコントローラに変える
  ans = analogRead(0);                       // AD0にアナログコントローラを刺す
  key = get_key(ans);                        // 読み取ったアナログ値を動作番号に変換する
  //ans = IRrecive() ;                       // 赤外線リモコンのデータを受信する

  if (key != oldkey)   // if keypress is detected
  {
    delay(50);  // wait for debounce time
    adc_key_in = analogRead(0);    // read the value from the sensor
    //Serial.println(adc_key_in, DEC);
    key = get_key(adc_key_in);    // convert into key press
    if (key != oldkey)
    { 
      //キーに変化があった時はPWMカウンタを初期化してON波形からPWM波形を打ち直す
      motorPwmOnCounter = 0;
      
      oldkey = key;
      if (key >= 0) {
        digitalWrite(13, HIGH);
        switch (key)
        {
          case 0: //Serial.println("S1 OK");
            mode = 1;       //赤ボタン（右）押されたモード
            //Serial.println("mode = 1");
            break;
          case 1: //Serial.println("S2 OK");
            mode = 2;       //赤ボタン（左）押されたモード
            //Serial.println("mode = 2");
            break;
          case 2: //Serial.println("S3 OK");
            if (mode == 0) {
              //左回転
              digitalWrite(8, HIGH);
              digitalWrite(9, LOW);
              digitalWrite(10, HIGH);
              digitalWrite(11, LOW);
              //  delay(250);
            } else if (mode == 1) {
              /////////////////////////////////////////////////////////////////////////
              //
              //ここに実行したい処理を記載する
              //
              /////////////////////////////////////////////////////////////////////////
              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            } else if (mode == 2) {
              /////////////////////////////////////////////////////////////////////////
              //
              //ここに実行したい処理を記載する
              //
              /////////////////////////////////////////////////////////////////////////
              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            }
            break;
          case 3: //Serial.println("S4 OK");
            if (mode == 0) {
              //前進
              digitalWrite(8, LOW);
              digitalWrite(9, HIGH);
              digitalWrite(10, HIGH);
              digitalWrite(11, LOW);
              //  delay(500);
            } else if (mode == 1) {
              //後退
              digitalWrite(8, HIGH);
              digitalWrite(9, LOW);
              digitalWrite(10, LOW);
              digitalWrite(11, HIGH);
              // delay(500);
              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            } else if (mode == 2) {
              /////////////////////////////////////////////////////////////////////////
              //
              //ここに実行したい処理を記載する
              //
              /////////////////////////////////////////////////////////////////////////
              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            }
            break;
          case 4: //Serial.println("S5 OK");
            if (mode == 0) {
              //右回転
              digitalWrite(8, LOW);
              digitalWrite(9, HIGH);
              digitalWrite(10, LOW);
              digitalWrite(11, HIGH);
              //delay(1000);
            } else if (mode == 1) {
              /////////////////////////////////////////////////////////////////////////
              //
              //ここに実行したい処理を記載する
              //
              /////////////////////////////////////////////////////////////////////////
              //Serial.println("servo_250");
              servo_1.write(90);              // tell servo to go to position in variable 'pos'
              servo_2.write(90);              // tell servo to go to position in variable 'pos'
              servo_3.write(90);              // tell servo to go to position in variable 'pos'
              servo_4.write(90);              // tell servo to go to position in variable 'pos'

              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            } else if (mode == 2) {
              /////////////////////////////////////////////////////////////////////////
              //
              //ここに実行したい処理を記載する
              //
              /////////////////////////////////////////////////////////////////////////
              //Serial.println("servo_950");

              servo_1.write(180);              // tell servo to go to position in variable 'pos'
              servo_2.write(180);              // tell servo to go to position in variable 'pos'
              servo_3.write(180);              // tell servo to go to position in variable 'pos'
              servo_4.write(180);              // tell servo to go to position in variable 'pos'

              //一回実行したらモードを戻す
              mode = 0;       //デフォルトモード
            }
            break;

          case 5: //Serial.println("key_up");

            break;
        }
       

      }
      else if (key == -1)
      {
        //key = -1のとき（ボタンを押していない状態）モーターを停止
        digitalWrite(8, LOW);
        digitalWrite(9, LOW);
        digitalWrite(10, LOW);
        digitalWrite(11, LOW);
        //Serial.println("motor_stop");
      }
    }
  }
  
  //モーター用PWMカウンタがカウントアップしたら、コントローラの指示に関わらず１サイクル停止する。
  if(motorPwmOnCounter > ONCYCLE){
    digitalWrite(8, LOW);
    digitalWrite(9, LOW);
    digitalWrite(10, LOW);
    digitalWrite(11, LOW);
    //モーター用PWM　OFFカウンタをインクリメントする
    motorPwmOffCounter = motorPwmOffCounter+1;
    if(motorPwmOffCounter > OFFCYCLE){
      //OFFカウンタがカウントアップしたらONカウンタをクリアする
      motorPwmOnCounter = 0;
    }
  }else{
    //モーター用PWM  ONカウンタをインクリメントする
    motorPwmOnCounter = motorPwmOnCounter+1;
    //OFFカウンタはクリアしておく
    motorPwmOffCounter = 0;
  }
  delay(100);
}
// 赤外線リモコンのデータを受信する処理関数
int IRrecive()
{
  unsigned long t ;
  int i , j ;
  int cnt , ans ;
  char IRbit[64] ;

  ans = 0 ;
  t = 0 ;
  if (digitalRead(IR_PIN) == LOW) {
    // リーダ部のチェックを行う
    t = micros() ;                          // 現在の時刻(us)を得る
    while (digitalRead(IR_PIN) == LOW) ;  // HIGH(ON)になるまで待つ
    t = micros() - t ;          // LOW(OFF)の部分をはかる
  }
  // リーダ部有りなら処理する(3.4ms以上のLOWにて判断する)
  if (t >= 3400) {
    i = 0 ;
    while (digitalRead(IR_PIN) == HIGH) ; // ここまでがリーダ部(ON部分)読み飛ばす
    // データ部の読み込み
    while (1) {
      while (digitalRead(IR_PIN) == LOW) ; // OFF部分は読み飛ばす
      t = micros() ;
      cnt = 0 ;
      while (digitalRead(IR_PIN) == HIGH) { // LOW(OFF)になるまで待つ
        delayMicroseconds(10) ;
        cnt++ ;
        if (cnt >= 1200) break ;    // 12ms以上HIGHのままなら中断
      }
      t = micros() - t ;
      if (t >= 10000) break ;      // ストップデータ
      if (t >= 1000)  IRbit[i] = (char)0x31 ;  // ON部分が長い
      else            IRbit[i] = (char)0x30 ;  // ON部分が短い
      i++ ;
    }
    // データ有りなら指定位置のデータを取り出す
    if (i != 0) {
      i = (DATA_POINT - 1) * 8 ;
      for (j = 0 ; j < 8 ; j++) {
        if (IRbit[i + j] == 0x31) bitSet(ans, j) ;
      }
    }
  }
  return ( ans ) ;
}
// アナログコントローラからのアナログ値を動作ナンバーに変換する関数
int get_key(unsigned int input)
{
  int k;
  for (k = 0; k < NUM_KEYS; k++)
  {
    if (input < adc_key_val[k])
    {
      return k;
    }
  }
  if (k >= NUM_KEYS)k = -1;  // No valid key pressed
  return k;
}
